define("soundManagerApi", ["componentmodelComponentApi", "clientkernelEventbusApi"],
    function(componentmodelComponentApi, clientkernelEventbusApi) {
        "use strict";

        function $iterator(o) {
            if (o instanceof Array) return function() {
                return {
                    cur: 0,
                    arr: o,
                    hasNext: function() {
                        return this.cur < this.arr.length;
                    },
                    next: function() {
                        return this.arr[this.cur++];
                    }
                };
            };
            return typeof(o.iterator) == 'function' ? $bind(o, o.iterator) : o.iterator;
        };;
        var $fid = 0;

        function $bind(o, m) {
            if (m == null) return null;
            if (m.__id__ == null) m.__id__ = $fid++;
            var f;
            if (o.hx__closures__ == null) o.hx__closures__ = {};
            else f = o.hx__closures__[m.__id__];
            if (f == null) {
                f = function() {
                    return f.method.apply(f.scope, arguments);
                };
                f.scope = o;
                f.method = m;
                o.hx__closures__[m.__id__] = f;
            }
            return f;
        };
        var $_;
        var $estr = function() {
            return _hcmn_.js_Boot.__string_rec(this, '');
        };
        if (typeof haxe == 'undefined') {
            var haxe = {};
        };

        haxe.IMap = function() {}
        haxe.IMap.prototype = {

        };
        if (typeof soundManagerApi == 'undefined') {
            var soundManagerApi = {};
        };
        soundManagerApi.SoundManagerDeclaration = function() {};
        soundManagerApi.SoundManagerDeclaration = ck_implements(soundManagerApi.SoundManagerDeclaration, componentmodelComponentApi.IComponentDeclaration);
        soundManagerApi.SoundManagerDeclaration.__interfaces__ = [componentmodelComponentApi.IComponentDeclaration];
        soundManagerApi.SoundManagerDeclaration.__name__ = ["soundManagerApi", "SoundManagerDeclaration"];
        soundManagerApi.SoundManagerDeclaration.prototype.getChildComponents = function() {
            return null;
        };
        soundManagerApi.SoundManagerDeclaration.prototype.getReferredComponents = function() {
            return null;
        };
        soundManagerApi.SoundManagerDeclaration.prototype.getImplementedPorts = function() {
            return [soundManagerApi.ISoundManagerImplementationPort];
        };
        soundManagerApi.SoundManagerDeclaration.prototype.getUsedPorts = function() {
            return [];
        };
        soundManagerApi.SoundManagerDeclaration.prototype.__class__ = soundManagerApi.SoundManagerDeclaration;

        soundManagerApi.ISoundManagerImplementationPort = function() {}
        soundManagerApi.ISoundManagerImplementationPort.prototype = {

            onLoaded: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getSoundActions: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            setGameMode: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            play: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            stop: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            fadeIn: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            fadeOut: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            mute: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            unmute: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            muteAll: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            unmuteAll: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };

        soundManagerApi.ISoundManagerPort = function() {}
        soundManagerApi.ISoundManagerPort.prototype = {

            onLoaded: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            getSoundActions: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            setGameMode: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            play: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            stop: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            fadeIn: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            fadeOut: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            mute: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            unmute: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            muteAll: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            },
            unmuteAll: function() {
                return {
                    arguments: [],
                    returns: "*"
                };
            }
        };
        soundManagerApi.SoundManagerPort = function(bus) {
            this.unmuteAllAction = new clientkernelEventbusApi.Topic("soundplayer:unmuteAll");
            this.muteAllAction = new clientkernelEventbusApi.Topic("soundplayer:muteAll");
            this.unmuteAction = new clientkernelEventbusApi.Topic("soundplayer:unmute");
            this.muteAction = new clientkernelEventbusApi.Topic("soundplayer:mute");
            this.fadeOutAction = new clientkernelEventbusApi.Topic("soundplayer:fadeOut");
            this.fadeInAction = new clientkernelEventbusApi.Topic("soundplayer:fadeIn");
            this.stopAction = new clientkernelEventbusApi.Topic("soundplayer:stop");
            this.playAction = new clientkernelEventbusApi.Topic("soundplayer:play");
            this.gameMode = new clientkernelEventbusApi.Topic("soundplayer:gameMode");
            this.soundActions = new clientkernelEventbusApi.Topic("soundplayer:soundActions");
            this.onSoundLoaded = new clientkernelEventbusApi.Topic("soundplayer:onLoaded");
            this.onSoundLoaded.connect(bus);
            this.soundActions.connect(bus);
            this.gameMode.connect(bus);
            this.playAction.connect(bus);
            this.stopAction.connect(bus);
            this.fadeInAction.connect(bus);
            this.fadeOutAction.connect(bus);
            this.muteAction.connect(bus);
            this.unmuteAction.connect(bus);
            this.muteAllAction.connect(bus);
            this.unmuteAllAction.connect(bus);
        };
        soundManagerApi.SoundManagerPort = ck_implements(soundManagerApi.SoundManagerPort, soundManagerApi.ISoundManagerPort);
        soundManagerApi.SoundManagerPort = ck_implements(soundManagerApi.SoundManagerPort, soundManagerApi.ISoundManagerImplementationPort);
        soundManagerApi.SoundManagerPort.__interfaces__ = [soundManagerApi.ISoundManagerPort, soundManagerApi.ISoundManagerImplementationPort];
        soundManagerApi.SoundManagerPort.__name__ = ["soundManagerApi", "SoundManagerPort"];
        soundManagerApi.SoundManagerPort.prototype.onSoundLoaded = null;
        soundManagerApi.SoundManagerPort.prototype.soundActions = null;
        soundManagerApi.SoundManagerPort.prototype.gameMode = null;
        soundManagerApi.SoundManagerPort.prototype.playAction = null;
        soundManagerApi.SoundManagerPort.prototype.stopAction = null;
        soundManagerApi.SoundManagerPort.prototype.fadeInAction = null;
        soundManagerApi.SoundManagerPort.prototype.fadeOutAction = null;
        soundManagerApi.SoundManagerPort.prototype.muteAction = null;
        soundManagerApi.SoundManagerPort.prototype.unmuteAction = null;
        soundManagerApi.SoundManagerPort.prototype.muteAllAction = null;
        soundManagerApi.SoundManagerPort.prototype.unmuteAllAction = null;
        soundManagerApi.SoundManagerPort.prototype.getSoundActions = function() {
            return this.soundActions;
        };
        soundManagerApi.SoundManagerPort.prototype.onLoaded = function() {
            return this.onSoundLoaded;
        };
        soundManagerApi.SoundManagerPort.prototype.setGameMode = function() {
            return this.gameMode;
        };
        soundManagerApi.SoundManagerPort.prototype.play = function() {
            return this.playAction;
        };
        soundManagerApi.SoundManagerPort.prototype.stop = function() {
            return this.stopAction;
        };
        soundManagerApi.SoundManagerPort.prototype.fadeIn = function() {
            return this.fadeInAction;
        };
        soundManagerApi.SoundManagerPort.prototype.fadeOut = function() {
            return this.fadeOutAction;
        };
        soundManagerApi.SoundManagerPort.prototype.mute = function() {
            return this.muteAction;
        };
        soundManagerApi.SoundManagerPort.prototype.unmute = function() {
            return this.unmuteAction;
        };
        soundManagerApi.SoundManagerPort.prototype.muteAll = function() {
            return this.muteAllAction;
        };
        soundManagerApi.SoundManagerPort.prototype.unmuteAll = function() {
            return this.unmuteAllAction;
        };
        soundManagerApi.SoundManagerPort.prototype.__class__ = soundManagerApi.SoundManagerPort;
        soundManagerApi.SoundManagerPortFactory = function() {};
        soundManagerApi.SoundManagerPortFactory = ck_implements(soundManagerApi.SoundManagerPortFactory, componentmodelComponentApi.IPortFactory);
        soundManagerApi.SoundManagerPortFactory.__interfaces__ = [componentmodelComponentApi.IPortFactory];
        soundManagerApi.SoundManagerPortFactory.__name__ = ["soundManagerApi", "SoundManagerPortFactory"];
        soundManagerApi.SoundManagerPortFactory.prototype.provide = function(channel) {
            return new soundManagerApi.SoundManagerPort(channel);
        };
        soundManagerApi.SoundManagerPortFactory.prototype["use"] = function(channel) {
            return new soundManagerApi.SoundManagerPort(channel);
        };
        soundManagerApi.SoundManagerPortFactory.prototype.__class__ = soundManagerApi.SoundManagerPortFactory;
        soundManagerApi.EGameMode = {
            __ename__: ["soundManagerApi", "EGameMode"],
            __constructs__: ["BaseGame", "FreeSpin"]
        };
        soundManagerApi.EGameMode.BaseGame = ["BaseGame", 0];
        soundManagerApi.EGameMode.BaseGame.toString = $estr;
        soundManagerApi.EGameMode.BaseGame.__enum__ = soundManagerApi.EGameMode;
        soundManagerApi.EGameMode.FreeSpin = ["FreeSpin", 1];
        soundManagerApi.EGameMode.FreeSpin.toString = $estr;
        soundManagerApi.EGameMode.FreeSpin.__enum__ = soundManagerApi.EGameMode;
        soundManagerApi.SoundActionProperties = function(soundId, length) {
            this.soundId = soundId;
            this.length = length;
        };
        soundManagerApi.SoundActionProperties.__name__ = ["soundManagerApi", "SoundActionProperties"];
        soundManagerApi.SoundActionProperties.prototype.soundId = null;
        soundManagerApi.SoundActionProperties.prototype.length = null;
        soundManagerApi.SoundActionProperties.prototype.__class__ = soundManagerApi.SoundActionProperties;
        return {
            exports: soundManagerApi
        };
    });
//# sourceURL=soundManagerApi.js